﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.8
@EndOfDesignText@

							                      
public Sub Class_Globals
	
	Private strConnString_ As String
	Private strStatus_ As String
	Private MsSQL_ As JdbcSQL
	Private strUserName_ As String
	Private strPassword_ As String
	Private blnIsConnected_ As Boolean
	Private ResultSet_ As JdbcResultSet		'The result set returned from a query.
	'Private ResultSetCursor As 
	Private blnEOF_ As Boolean
	Private strLastQuery_ As String
	Private blnHasRecords_ As Boolean
	Private lngRecordCount_ As Long
	Private lngCurrentRecord_ As Long
	
	
	Type DATATYPE(AlphaNumeric As Int, Numeric As Int)
	Public Const DATATYPE_VARCHAR=0, DATATYPE_DOUBLE=1, DATATYPE_INT=2, DATATYPE_BLOB=3 As Int

	Private imgTest As ImageView
End Sub




'Initializes the DAL (Data Access Layer) object.
'Must be called first before the library can be used.
'Pass it your Database Credentials (Username and Password), the Server IP or Address and the Database Name you wish to connect to. 
'Server Port is Optional and may be left blank, but is usually 1433.
Public Sub Initialize(strUserName As String,strPassword As String,strServerIPOrAddress As String,strDatabaseName As String,strPort As String)
	
	strUserName_ = strUserName
	strPassword_ = strPassword
	strConnString_ = ""
	blnIsConnected_ = False
	blnEOF_ = False
	strStatus_ = "Connection Closed"
	strLastQuery_ = ""
    blnHasRecords_ = False
	lngRecordCount_ = 0
    lngCurrentRecord_ = -1


    If strPort.Trim <> "" Then
		
		'MySQL
		'strConnString_ = "jdbc:mysql://" & strServerIPOrAddress & ":" & strPort & "/" & strDatabaseName
		
		'If a Port number was supplied.
		strConnString_ = "jdbc:jtds:sqlserver://" & strServerIPOrAddress & ":" & strPort & "/" & strDatabaseName
	Else
		strConnString_ = "jdbc:jtds:sqlserver://" & strServerIPOrAddress & "/" & strDatabaseName
	End If
	
	
End Sub



'Splits the passed string at the passed separator character.
'Example:
'Dim strTemp() As String = JRStrings.Split("This is a test"," ")
'strTemp(0) would return 'This'
'strTemp(1) would return 'is' etc.....
Private Sub Split(strString As String, strSeparatorCharacter As String) As String()
	
	Dim strTemp() As String
	strTemp = Regex.Split(strSeparatorCharacter,strString)
	
	Return strTemp
	
End Sub



'Input is DD/MM/YYYY output is MM/DD/YYYY.
'NOTE: Useful when working with a date column used in a SQL format which seems to require the dates in American format.
Public Sub ConvertDateToAmericanFormat(strInputDate As String, blnAddZeros As Boolean) As String

        Try

            
            Dim strTemp() As String
            
			
			If strInputDate.Contains("/") = True Then
				strTemp = Split(strInputDate,"/")     
			End If
			
			If strInputDate.Contains("-") = True Then
				strTemp = Split(strInputDate,"-")
			End If
			

            If blnAddZeros = True Then

                'Day
                If strTemp(0).Length < 2 Then
                    strTemp(0) = "0" & strTemp(0)
                End If

                'Month
                If strTemp(1).Length < 2 Then
                    strTemp(1) = "0" & strTemp(1)
                End If


            Else

                'Day
                If strTemp(0).StartsWith("0") = True Then
                   ' strTemp(0) = Mid(strTemp(0), 2, 1)
					strTemp(0) = strTemp(0).SubString2(2,3)
                End If

                'Month
                If strTemp(1).StartsWith("0") = True Then
                    'strTemp(1) = Mid(strTemp(1), 2, 1)
				strTemp(1) = strTemp(1).SubString2(2,3)
                End If


            End If



            'To cater for the different date settings a user may have on their PC, we need to check if the month is a varchar e.g. 'Oct'
            'instead of 10, if it is we change it for the numerical equivalent of the month.
            Select Case strTemp(1).Trim.ToLowerCase

                Case "jan"
                    strTemp(1) = "01"
                Case "feb"
                    strTemp(1) = "02"
                Case "mar"
                    strTemp(1) = "03"
                Case "apr"
                    strTemp(1) = "04"
                Case "may"
                    strTemp(1) = "05"
                Case "jun"
                    strTemp(1) = "06"
                Case "jul"
                    strTemp(1) = "07"
                Case "aug"
                    strTemp(1) = "08"
                Case "sep"
                    strTemp(1) = "09"
                Case "oct"
                    strTemp(1) = "10"
                Case "nov"
                    strTemp(1) = "11"
                Case "dec"
                    strTemp(1) = "12"
                Case Else
                    'Do nothing cause month is in correct format already, ie numerical.

            End Select



            Return strTemp(1) & "/" & strTemp(0) & "/" & strTemp(2)


        Catch
			Return Null
        End Try


End Sub



'Returns the no of records in the specified table.
Public Sub GetTableRecordCount(strTableName As String) As Int
	
	ExecSQLReader("SELECT COUNT(*) AS Count FROM " & strTableName)
	
	If strStatus_ = "" Then	
		Dim intCount As Int =  Item("Count",DATATYPE_INT)
		Return intCount
	Else
		Return Null			
	End If
	
End Sub



'Returns the Record ID of the last Record inserted from calling the 'ExecSQLNonQuery' sub and performing a Table Insert.
'NOTE: This should be called immediately after an Insert to get the correct result.
Public Sub GetLastInsertedRecordID(strRecIDColumnName As String, strTableName As String) As Int
  
     ExecSQLReader("SELECT MAX(" & strRecIDColumnName & ") AS RecID FROM " & strTableName) 
		
     If strStatus_ = "" Then
		Dim intRecID As Int =  Item("RecID",DATATYPE_INT)
		Return intRecID
	Else
		Return Null	
	End If

 End Sub



'Run a Query on the connected Database and Return Results which may then be accessed by calling 'Item'.
'See description of Library.
Public Sub ExecSQLReader(strSQL As String)
	
	blnEOF_ = False
	blnHasRecords_ = False
	lngRecordCount_ = 0
	strStatus_ = ""
	strLastQuery_ = strSQL
	lngCurrentRecord_ = -1
	ExecSQLReader_
	
End Sub



'Run a Non Query on the Database, such as a Update or Insert.
Public Sub ExecSQLNonQuery(strSQL As String)
	
	blnEOF_ = False
	blnHasRecords_ = False
	lngRecordCount_ = 0
	strStatus_ = ""
	strLastQuery_ = strSQL
	lngCurrentRecord_ = -1
	ExecSQLNonQuery_
	
End Sub



'--------------------------------------------------------------------------------------------
'Try to establish a connection to our remote Database.
'It is a ResumableType sub since we want to wait for it to finish trying to establish a connection
'before we continue.
'Private Sub Connect As ResumableSub
'		
'	'The 'mssql_' here is the name of our internal driver variable.
'	MsSQL_.InitializeAsync("mssql_","net.sourceforge.jtds.jdbc.Driver", strConnString_, strUserName_, strPassword_)
'	'MsSQL_.Initialize2("net.sourceforge.jtds.jdbc.Driver", strConnString_, strUserName_, strPassword_)
'	'Wait For MsSQL__Ready (Success As Boolean)
'	If Success = False Then
'		strStatus_ = "Could not Connect. Please check 'Initialize' parameters are correct."
'	Else
'		strStatus_ = ""
'	End If
'	
'	Return Success
'	
'End Sub


'Tests a connection to the specified Database by using the passed credentials.
'Will return TRUE if the connection succeeds, or FALSE if it fails.
Public Sub IsConnectionOK(strUserName As String, strPassword As String, strServerIPOrAddress As String, strDatabaseName As String, strPort As String) As Boolean
	
	
	If strPort.Trim <> "" Then
		strConnString_ = "jdbc:jtds:sqlserver://" & strServerIPOrAddress & ":" & strPort & "/" & strDatabaseName
	Else
		strConnString_ = "jdbc:jtds:sqlserver://" & strServerIPOrAddress & "/" & strDatabaseName
	End If
	
	strUserName_ = strUserName
	strPassword_ = strPassword
	
	
	Connect
	
	
	If strStatus_ = "" Then		
		If blnIsConnected_ = True Then
			Close
			Return True
		Else
			Return False
		End If
	Else
		Return False
	End If 
	
	
	
End Sub



'Connect to the Remote MS SQL Database.
Private Sub Connect

	blnEOF_ = False
	blnHasRecords_ = False
	lngRecordCount_ = 0

	Try
	
	    'My SQL
		'MsSQL_.Initialize2("com.mysql.jdbc.Driver", strConnString_, strUserName_, strPassword_)
		
		MsSQL_.Initialize2("net.sourceforge.jtds.jdbc.Driver", strConnString_, strUserName_, strPassword_)
		
		If MsSQL_.IsInitialized = True Then
			strStatus_=""
			blnIsConnected_ = True
			Return
		Else
			strStatus_ = "Error Connecting to Database"
			blnIsConnected_ = False
			Return
		End If
	
	Catch
		strStatus_ = LastException
	End Try
	
	
End Sub



'Will return TRUE if a connection has been successfully established to the Remote Database or FALSE if not.
Public Sub IsConnected() As Boolean
	Return blnIsConnected_
End Sub



'Close the connection to the Remote Database. 
'Always call this right at the end when you have finished running a Query/Non Query.
Public Sub Close
	
	Try
		MsSQL_.Close
		strStatus_= ""
	Catch
		strStatus_ = LastException
		Return
	End Try
	
	blnIsConnected_ = False
	blnHasRecords_ = False
	blnEOF_ = False	
	lngRecordCount_ = 0
	strLastQuery_ = ""
	
End Sub



'After running a 'ExecSQLReader' command and if Records have been returned, this will move Resultset to the next record.
'This is useful for iterating through records, or if you want to populate a listview etc.
'If the Resultset has moved passed the last record, the 'EOF' flag will be set to TRUE indicating End Of File.
Public Sub MoveNext
	
	Dim blnTemp As Boolean
	
	Try
		'Move to the next record in the result set.
		blnTemp = ResultSet_.NextRow
		'Dim lngTemp As Long
		
		lngCurrentRecord_ = lngCurrentRecord_ + 1
		
'		If ResultSetCursor.Position < ResultSetCursor.RowCount-1 Then
'			lngTemp = ResultSetCursor.Position
'			lngTemp = lngTemp + 1
'			ResultSetCursor.Position = lngTemp
'			blnEOF_ = False
'		Else
'			blnEOF_ = True		
'		End If
'	
'		
	Catch
		strStatus_ = LastException
		Return
	End Try
	
	
	'If a False was returned it means the record set Is at the End.
	If blnTemp = False Then
		blnEOF_ = True
		lngCurrentRecord_ = -1
	Else
		blnEOF_ = False
	End If
	
	
	strStatus_ = ""
	
	
End Sub



'Get if the Resultset is at EOF (End of File).
'This will always return FALSE if no 'ExecSQLReader' command was run.
Public Sub EOF() As Boolean
	Return blnEOF_
End Sub



'Get a column  value from the Resultset by the Column Name, returns the value as a String.
Public Sub ItemString(strColumnName As String) As String
	
	strStatus_ = ""
	
	Try
		
		Return ResultSet_.GetString(strColumnName)
		
		
	Catch
		strStatus_ = LastException
		Return Null
	End Try
	
	
End Sub



'Get a Column value from the Resultset by the Column Name.
'First run the 'ExecSQLReader' command to get Record/s.
'Example Usage:
'Dim strSurname As String = DAL.Item("varClientSurname", DAL.DATATYPE_VARCHAR)
'Possible DataTypes are:
'Varchar - Alphanumeric/Strings
'Double - Floating Point Number
'Int - Integer
'Blob - Binary Data such as an Image.
Public Sub Item(strColumnName As String, strDataType As Object) As Object
	
	Try
	
	    strStatus_ = ""
	

		Select strDataType
		
			Case 0	'Varchar
				Return ResultSet_.GetString(strColumnName)
			
			Case 1   'Double
				Return ResultSet_.GetDouble(strColumnName)
			
			Case 2   'Integer
				Return ResultSet_.GetInt(strColumnName)
			
			Case 3   'Blob (Image)
				Return ResultSet_.GetBlob(strColumnName)
			
		End Select
		
		
	Catch
		strStatus_ = LastException
		Return Null
	End Try
	
	
	Return Null
	
	
End Sub



'Returns how many Records there are currenty in the Resultset.
Public Sub RecordCount() As Long	
	Return lngRecordCount_	
End Sub



'Returns the last SQL query issued to the DAL.
Public Sub LastQuery() As String	
	Return strLastQuery_
End Sub



'Returns if the Resultset has records or not, the Resultset can only possibly contain records after a call to 'ExecSQLReader'.
Public Sub HasRecords() As Boolean
	Return blnHasRecords_
End Sub



'Returns the current Resultset from issuing a 'ExecSQLReader' command.
Public Sub GetResultSet() As JdbcResultSet	
	Return ResultSet_
End Sub



'Returns the no of columns in the current Resultset after issuing a 'ExecSQLReader' command.
Public Sub GetResultSetNoColumns() As Int
	Return ResultSet_.ColumnCount
End Sub



'Run a Query on the connected Database and returns specific rows as specified by Start and End Row.
'For example if a Query would normally return 100 rows, this sub could just return row 40-50 if required, or any other combination.
'This is useful when paging is needed so that not all the records are returned at once, but rather a subset of the records to increase performance.
'If blnIncludeRowNumberInResults is set to TRUE, then a column containing the row number will also be added to the results and will be called 'rownum'.
'Example Usage:
'DAL.ExecSQLReaderRange("SELECT Column1,Column2 FROM MyTable WHERE Column1 = 1 ORDER BY Column1","id",5,10,False)
'This will return records 5-10 in the above query.
Public Sub ExecSQLReaderRange(strSQL As String, strRecIDColumnName As String, lngStartRow As Long, lngEndRow As Long, blnIncludeRowNumberInResults As Boolean)

	Try
	
	
		Dim intStartIndex_Of_FROM_Keyword As Int = strSQL.ToLowerCase.IndexOf("from")         'The character index in the SQL string of the 'F' of FROM (where FROM starts in the text)
		Dim intStartIndex_Of_WHERE_Keyword As Int = strSQL.ToLowerCase.IndexOf("where")       'The character index in the SQL string of the 'W' of WHERE (where WHERE starts in the text)
		Dim intStartIndex_Of_ORDERBY_Keyword As Int = strSQL.ToLowerCase.IndexOf("order by")  'The character index in the SQL string of the 'O' of ORDER BY (where ORDER BY starts in the text)
		
		Dim strListOfColumnNamesToSelect As String					'The column names which will appear in the results, ie. Col1,Col2
		Dim strListOfColumnNamesToSelectWithoutRowNum As String     'The column names which will appear in the results, with rownum at the end, ie. Col1,Col2,rownum
		Dim strOrderBy As String									'The info contained in the order by clause (the part just after the ORDER BY keyword)
		Dim strWhere As String      								'The info contained in the where clause (the part just after the WHERE keyword)
		
		
		
		
		'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		'Get the Table name we are SELECTING from.
		Dim strTableNameSelectingFrom As String
		If intStartIndex_Of_WHERE_Keyword <> -1 Then
			'If there is a WHERE clause.
			'SELECT Col1, Col2 FROM MyTable WHERE Col1 = 1 ORDER BY Col1
			'Extract the Table Name which is just after where 'FROM' ends and just before where 'WHERE' starts.
			strTableNameSelectingFrom = strSQL.SubString2(intStartIndex_Of_FROM_Keyword + 5, intStartIndex_Of_WHERE_Keyword - 1)
		
		Else
			'There is no WHERE clause.
									
			If intStartIndex_Of_ORDERBY_Keyword <> - 1 Then
				'There is a ORDER BY clause.
				'SELECT Col1, Col2 FROM MyTable ORDER BY Col1
				'Extract the Table Name which is just after where 'FROM' ends and just before where 'ORDER BY' starts.	
				strTableNameSelectingFrom = strSQL.SubString2(intStartIndex_Of_FROM_Keyword + 5, intStartIndex_Of_ORDERBY_Keyword - 1)
			Else
				'There is no ORDER BY clause so we can just go to the end of the string.
				'SELECT Col1, Col2 FROM MyTable
				'Extract the Table Name which is just after where 'FROM' ends, till the end of the string.
				strTableNameSelectingFrom = strSQL.SubString(intStartIndex_Of_FROM_Keyword + 5)
			End If
		End If
		
		
		
			
	    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		'Look if there is a WHERE clause.
		If intStartIndex_Of_WHERE_Keyword <> -1 Then
			'There is a WHERE clause....
			
			'Now check if there is an ORDER BY clause....
			If intStartIndex_Of_ORDERBY_Keyword <> -1 Then
				'....there is an ORDER BY clause....
				'SELECT Col1, Col2 FROM MyTable WHERE Col1 = 1 ORDER BY Col1
				'Extract the WHERE CLAUSE info which is just after where 'WHERE' ends and just before where 'ORDER BY' starts.
				strWhere = " AND " & strSQL.SubString2(intStartIndex_Of_WHERE_Keyword + 6, intStartIndex_Of_ORDERBY_Keyword - 1)
				
			Else
				'...there is no ORDER BY clause....
				''SELECT Col1, Col2 FROM MyTable WHERE Col1 = 1
				'Extract the WHERE CLAUSE info which is just after where 'WHERE' ends, till the end of the string.
				strWhere = strSQL.SubString(intStartIndex_Of_WHERE_Keyword)
			End If
					
		Else
			'There is no WHERE clause.
			strWhere = ""
		End If




        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		'Look if there is an ORDER BY clause.
	    If intStartIndex_Of_ORDERBY_Keyword <> -1 Then
			'There is an ORDER BY clause.
			'SELECT Col1, Col2 FROM MyTable WHERE Col1 = 1 ORDER BY Col1
			'Extract the ORDER BY info which is just after where 'ORDER BY' ends, till the end of the string.
			strOrderBy = "ORDER BY Resultset." & strSQL.SubString(intStartIndex_Of_ORDERBY_Keyword + 9)
		Else
			'There is no ORDER BY clause.
			'SELECT Col1, Col2 FROM MyTable WHERE Col1 = 1
			strOrderBy = ""	
		End If
		
			
			
			
		'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		'Should we include 'rownum' in the results?
		If blnIncludeRowNumberInResults = False Then
			strListOfColumnNamesToSelect = strSQL.SubString2(7,intStartIndex_Of_FROM_Keyword-1)
		Else
			strListOfColumnNamesToSelect = strSQL.SubString2(7,intStartIndex_Of_FROM_Keyword-1) & ",rownum"
		End If


		strListOfColumnNamesToSelectWithoutRowNum = strSQL.SubString2(7,intStartIndex_Of_FROM_Keyword-1)




        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		'Now finallly prepare the SQL which will just return the records from Start to End row.
	    Dim strTempSQL As String
		strTempSQL = "DECLARE @BeginRowNo INT = " & lngStartRow & ",  @EndRowNo INT = " & lngEndRow & " "
		strTempSQL = strTempSQL & "SELECT " & strListOfColumnNamesToSelect & " FROM (SELECT ROW_NUMBER() OVER (ORDER BY " & strRecIDColumnName & ") AS RowNum," & _
		strListOfColumnNamesToSelectWithoutRowNum & " FROM " & strTableNameSelectingFrom & ") AS ResultSet WHERE ResultSet.RowNum >= @BeginRowNo AND ResultSet.RowNum <= @EndRowNo " & strWhere & " " & _
		strOrderBy



		blnEOF_ = False
		blnHasRecords_ = False
		lngRecordCount_ = 0
		strStatus_ = ""
		strLastQuery_ = strTempSQL
		lngCurrentRecord_ = -1
		ExecSQLReader_
	
	
	Catch
		
		strStatus_ = LastException
		
	End Try
	


End Sub


'Used for Inserts & Updates to the Database only.
Private Sub ExecSQLNonQuery_ 
	
	'First we try to establish a connection to our database and wait until it is finished trying to connect....
	'Wait For (Connect) Complete (Success As Boolean)
	
	Connect
	
		
	Try
				
		'If we have successfully connected...
		If blnIsConnected_ = True Then		
			MsSQL_.ExecNonQuery(strLastQuery_)
			strStatus_ = ""
			Return 
		Else		
			strStatus_ = "Could not Connect to Database"	
			Return 
		End If
				
		
	Catch
		strStatus_ = LastException
		Return 
	End Try


	'strStatus_ = ""
	
End Sub




'---------------------------------------------------------------------------------------------
'The internal sub which actually does the work of fetching our SQL query results.
'We need to use a type ResumableSub so that we can actually wait until it is finshed trying to connect, before the code which does the 
'query executes.
'Private Sub ExecSQLReader_ As ResumableSub
Private Sub ExecSQLReader_
	
	
	'First we try to establish a connection to our database...
	Connect
	
	
	Try
			
			'If we have successfully connected...	
			If blnIsConnected_ = True Then		
					
				 'Execute our Query.
			     ResultSet_ = MsSQL_.ExecQuery(strLastQuery_)
								
											
				'Count the records.
				'We have no way of going back in the resultset once we call .NextRow so the only way I can get this too work
				'right now is too do the query again a 2nd time to re-populate the Resultset otherwise when we call 'Item' we get 
				'null as the resultset is at the end.
				'It is obviously not ideal calling the query twice but I do not know how to make a copy of the resultset as yet.
				lngRecordCount_ = 0
				Do While ResultSet_.NextRow <> False
					lngRecordCount_ = lngRecordCount_ + 1
				Loop
						
		
		
				If lngRecordCount_ > 0 Then
					blnHasRecords_ = True
					ResultSet_ = MsSQL_.ExecQuery(strLastQuery_)
					
					'Move to the first row.
					ResultSet_.NextRow
				Else
					blnHasRecords_ = False
				End If
			
											
			
			Else
				
				strStatus_ = "Could not Connect to Database"
				Return
				
			End If
		
		Catch
			strStatus_ = LastException
			Return
		End Try


		strStatus_ = ""

	
End Sub



'Gets the current status of the Database object.
'If the Status is blank it means everything is fine, otherwise it will contain the Error.
Public Sub Status As String
	Return strStatus_
End Sub



'Populates a Spinner (Dropdown list) control with the results from the Database Query.
'The 'strDisplayTextColumnName' parameter is the name of the database column who's value you want to be displayed (Added to the dropdown list) in the Spinner, for example a person's surname.
'The 'strValueColumnName' parameter is the name of the database column who's value you want to be used as the value for the item added to the spinner, usually this is the Record ID.
Public Sub ExecPopulateSpinnerDropDownFromQuery(strQuery As String, strDisplayTextColumnName As String, strValueColumnName As String, SpinnerDropDown As Spinner, SpinnerMap As Map)
	
	
	ExecSQLReader(strQuery)
		
		
	'Clear our drop down list.
	SpinnerDropDown.Clear
	SpinnerMap.Clear   			'The map used to associate values to dropdown items.
		
		
	If Status = "" Then
		If HasRecords = True Then
			
			Dim objDisplayText As Object
			Dim objValue As Object
			
			
			Do While EOF = False
				
				objDisplayText = Item(strDisplayTextColumnName, DATATYPE_VARCHAR)				
				objValue = Item(strValueColumnName, DATATYPE_VARCHAR)
				
				SpinnerDropDown.Add(objDisplayText)
				SpinnerMap.Put(objDisplayText,objValue)
				
				MoveNext
				
			Loop
		
			
			SpinnerDropDown.SelectedIndex = 0
			
		End If
	End If
		
	
	Close
	
End Sub




'Gets a File which was stored as binary from the Database and saves it to the path specified.
'Can be used to retreive a document, PDF, image etc and save it as a file.
'NOTE: Used to return and save a single record at a time.
'''''''''''''''''''''''''''''''''''''''''''''''''
'Example Usage:
'DAL.ExecGetFile(File.DirRootExternal,"MyImage.jpg","MyTableName","MyImageColumnName",2,"MyRecordIDColumnName")
'''''''''''''''''''''''''''''''''''''''''''''''''
'File.DirInternal / File.DirInternalCache
'These two folders are stored in the Main memory And are Private To your Application. Other applications cannot access these files.
'The cache folder may get deleted by the OS If it needs more space.
''''''''''''''''''''''''''''''''''''''''''''''''
'File.DirRootExternal
'The storage card root folder.
''''''''''''''''''''''''''''''''''''''''''''''''
'File.DirDefaultExternal
'The default folder For your Application in the SD card.
'The folder Is: storage card/Android/data/package/files/
'It will be created If required.
Public Sub ExecGetFile(strOutputFolder As String, strOutputFileName As String, strTableName As String, strColumnName As String, lngRecID As Long, strRecIDColumnName As String) 
	
	'Connect to the Database.
	Connect
	
	
	Dim Buffer() As Byte
	
	
	Try
		
		
		blnHasRecords_ = False
		lngRecordCount_ = 0
		
		strLastQuery_ = "SELECT " & strColumnName & " FROM " & strTableName & " WHERE " & strRecIDColumnName & " = " & lngRecID
		ResultSet_ =  MsSQL_.ExecQuery("SELECT " & strColumnName & " FROM " & strTableName & " WHERE " & strRecIDColumnName & " = " & lngRecID)
		
		'Move to first row.
		ResultSet_.NextRow
		
		'Get byte array from the Resultset.
		Buffer = ResultSet_.GetBlob(strColumnName)
		
		'If output folder was left blank, default it.
		If strOutputFolder.Trim = "" Then
			strOutputFolder = File.DirRootExternal
		End If
		
		'Save the file to disk.
		BytesArrayToFile(strOutputFolder,strOutputFileName,Buffer)
		
	
		strStatus_ = ""
		blnHasRecords_ = True
		lngRecordCount_ = 1
		lngCurrentRecord_ = 0
		blnEOF_ = False
		
		
		'Close the database connection again.
		Close
		
		'Return Bitmap1
	
	
	Catch
	
		'An error occurred or there were no records.
		blnHasRecords_ = False
		blnEOF_ = False
		strStatus_ = LastException
		lngCurrentRecord_ = 0
		lngCurrentRecord_ = -1
		
		
		'Close the database connection again.
		Close
		
		Return
		'Return Null
	
	End  try
	
	
	
End Sub



'Gets an Image which was stored as binary from the Database ands returns it as a Bitmap.
'NOTE: This sub should be used purely to retreive images which were stored in the database as it returns a bitmap from the binary data.
'NOTE: Used to return and save a single image at a time.
'Example Usage:
'imgTest.Bitmap = DAL.ExecGetImageAsBitmap("MyTableName","MyImageColumnName",2,"MyRecordIDColumnName")
Public Sub ExecGetImageAsBitmap(strTableName As String, strColumnName As String, lngRecID As Long, strRecIDColumnName As String) As Bitmap
	
	'Connect to the Database.
	Connect
	
	
	Dim Buffer() As Byte
	Dim InputStream As InputStream
	Dim Bitmap1 As Bitmap
	
	Try
		
		blnEOF_ = False
		blnHasRecords_ = False
		lngRecordCount_ = 0
		
		strLastQuery_ = "SELECT " & strColumnName & " FROM " & strTableName & " WHERE " & strRecIDColumnName & " = " & lngRecID
		ResultSet_ =  MsSQL_.ExecQuery("SELECT " & strColumnName & " FROM " & strTableName & " WHERE " & strRecIDColumnName & " = " & lngRecID)
		
		'Move to first row.
		ResultSet_.NextRow
		
		Buffer = ResultSet_.GetBlob(strColumnName)
		InputStream.InitializeFromBytesArray(Buffer, 0, Buffer.Length)
		Bitmap1.Initialize2(InputStream)
		InputStream.Close
		strStatus_ = ""
		blnHasRecords_ = True
		lngRecordCount_ = 1
		lngCurrentRecord_ = 0
	
		
		'Close the database connection again.
		Close
		
		Return Bitmap1
	
	
	Catch
	
		'An error occurred or there were no records.
		blnHasRecords_ = False
		blnEOF_ = False
		lngRecordCount_ = 0
		lngCurrentRecord_ = -1
		strStatus_ = LastException
		
		'Close the database connection again.
		Close
		
		Return Null
	
	End  try
	
	
	
End Sub



'Saves Binary data (Such as an Image or File) to the Database.
'For MS SQL use a column type of varbinary(MAX).
Public Sub ExecSaveFileAsBinary(strTableName As String, strColumnName As String, lngRecID As Long, strRecIDColumnName As String, strFilePathName As String)
	
	'Connect to the Database.
	Connect
	
	Try
	
	lngRecordCount_ = 0
	lngCurrentRecord_ = -1
	blnHasRecords_ = False
	blnEOF_ = False
  
	'Convert the image file to a bytes array
	Dim buffer() As Byte = File.ReadBytes(File.DirAssets, strFilePathName)
  
	strLastQuery_ = "UPDATE " & strTableName & " SET " & strColumnName & " = ? WHERE " & strRecIDColumnName & " = " & lngRecID
	MsSQL_.ExecNonQuery2("UPDATE " & strTableName & " SET " & strColumnName & " = ? WHERE " & strRecIDColumnName & " = " & lngRecID, Array As Object(buffer))
	
	
	Catch
		strStatus_ = LastException
		Close
		Return
	End Try


	strStatus_ = ""
    Close
	
End Sub



Private Sub ImageBitmapToBytes(Image As Bitmap) As Byte()
	Dim out As OutputStream
	out.InitializeToBytesArray(0)
	Image.WriteToStream(out, 100, "JPEG")
	out.Close
	Return out.ToBytesArray
End Sub


Private Sub BytesToImageBitmap(bytes() As Byte) As Bitmap
	Dim In As InputStream
	In.InitializeFromBytesArray(bytes, 0, bytes.Length)
	Dim bmp As Bitmap
	bmp.Initialize2(In)
	Return bmp
End Sub


Private Sub BytesArrayToFile (Dir As String, FileName As String, Data() As Byte)
	Dim out As OutputStream = File.OpenOutput(Dir, FileName, False)
	out.WriteBytes(Data, 0, Data.Length)
	out.Close
End Sub


Private Sub FileToBytesArray (Dir As String, FileName As String) As Byte()
	Return Bit.InputStreamToBytes(File.OpenInput(Dir, FileName))
End Sub



'Not yet sure if this is needed to set permissions??
'Private Sub DisableStrictMode
'	Dim jo As JavaObject
'	jo.InitializeStatic("android.os.Build.VERSION")
'	If jo.GetField("SDK_INT") > 9 Then
'		Dim policy As JavaObject
'		policy = policy.InitializeNewInstance("android.os.StrictMode.ThreadPolicy.Builder", Null)
'		policy = policy.RunMethodJO("permitAll", Null).RunMethodJO("build", Null)
'		Dim sm As JavaObject
'		sm.InitializeStatic("android.os.StrictMode").RunMethod("setThreadPolicy", Array(policy))
'	End If
'End Sub

